unit fOptions;
////////////////////////////////////////////////////////////////////////////////
// Unit:            fOptions
//
// Application:     ICS POP3 Client (HADP99 Demo)
//
// Purpose:         POP client server configuration dialog.
//
// Author:          Tres Seaver, Palladion Software.
//
// History:         1999/04/13      Original version
////////////////////////////////////////////////////////////////////////////////

interface

uses  Windows
    , SysUtils
    , Classes
    , Graphics
    , Forms
    , Controls
    , StdCtrls
    , Buttons
    , ExtCtrls
    , Pop3Prot
    , SmtpProt
    ;

type

  TdlgMailServerOptions = class( TForm )
    lblPOP3Options      : TLabel;
    bvlPOP3Options      : TBevel;
    lblPOP3Hostname     : TLabel;
    edtPOP3Hostname     : TEdit;
    lblPOP3PortNumber   : TLabel;
    edtPOP3PortNumber   : TEdit;
    lblPOP3UserName     : TLabel;
    edtPOP3UserName     : TEdit;
    lblPOP3Password     : TLabel;
    edtPOP3Password     : TEdit;
                                
    lblSMTPOptions      : TLabel;
    bvlSMTPOptions      : TBevel;
    lblSMTPHostname     : TLabel;
    edtSMTPHostname     : TEdit;
    lblSMTPPortNumber   : TLabel;
    edtSMTPPortNumber   : TEdit;
    lblSMTPSignOn       : TLabel;
    edtSMTPSignOn       : TEdit;

    btnOK               : TButton;
    btnCancel           : TButton;

    procedure btnOKClick( Sender : TObject );

  private

    FPOP3Client         : TPop3Cli;
    FSMTPClient         : TSMTPCli;

    procedure SetPOP3Client( newValue : TPop3Cli );
    procedure SetSMTPClient( newValue : TSMTPCli );

  public

    property POP3Client : TPop3Cli
        read FPOP3Client
       write SetPOP3Client;

    property SMTPClient : TSMTPCli
        read FSMTPClient
       write SetSMTPClient;
  end;

var
  dlgMailServerOptions: TdlgMailServerOptions;

implementation

{$R *.DFM}

procedure TdlgMailServerOptions.SetPOP3Client( newValue : TPop3Cli );
begin
    FPOP3Client := newValue;
    with POP3Client do
    begin
        edtPOP3Hostname.Text    := Host;
        edtPOP3PortNumber.Text  := Port;
        edtPOP3Username.Text    := Username;
        edtPOP3Password.Text    := Password;
    end;
end;


procedure TdlgMailServerOptions.SetSMTPClient( newValue : TSMTPCli );
begin
    FSMTPClient := newValue;
    with SMTPClient do
    begin
        edtSMTPHostname.Text    := Host;
        edtSMTPPortNumber.Text  := Port;
        edtSMTPSignOn.Text      := SignOn;
    end;
end;


procedure TdlgMailServerOptions.btnOKClick( Sender : TObject );
begin
    with POP3Client do
    begin
        Host           := edtPOP3Hostname.Text;
        Port           := edtPOP3PortNumber.Text;
        UserName       := edtPOP3Username.Text;
        PassWord       := edtPOP3Password.Text;
    end;

    with SMTPClient do
    begin
        Host            := edtSMTPHostname.Text;
        Port            := edtSMTPPortNumber.Text;
        SignOn          := edtSMTPSignOn.Text;
    end;
end;

end.
