unit fSendMail;

interface

uses  Windows
    , Messages
    , SysUtils
    , Classes
    , Graphics
    , Controls
    , Forms
    , Dialogs
    , SmtpProt
    , StdCtrls
    , ComCtrls
    , ExtCtrls
    ;

type

    TfrmSMTPMessage = class( TForm )

      pnlTop            : TPanel;
      pnlStatus         : TStatusBar;
      mmoMessageBody    : TMemo;
      lblTo             : TLabel;
      edtTo             : TEdit;
      lblFrom           : TLabel;
      edtFrom           : TEdit;
      lblSubject        : TLabel;
      edtSubject        : TEdit;
      btnSendIt         : TButton;
      SmtpClient        : TSmtpCli;

      procedure UpdateSMTPStatus( Sender        : TObject
                                ; Msg           : String
                                );

      procedure GetMessageBodyLine( Sender      : TObject
                                  ; LineNum     : Integer
                                  ; MsgLine     : PChar
                                  ; MaxLen      : Integer
                                  ; var More    : Boolean
                                  );

      procedure SMTPRequestDone( Sender         : TObject
                               ; RqType         : TSmtpRequest
                               ; Error          : Word
                               );

      procedure btnSendItClick( Sender          : TObject );
  end;

var
    frmSMTPMessage  : TfrmSMTPMessage;

implementation

{$R *.DFM}

procedure TfrmSMTPMessage.UpdateSMTPStatus( Sender  : TObject
                                          ; Msg     : String
                                          );
begin
    pnlStatus.Panels[ 0 ].Text := Msg;
end;

procedure TfrmSMTPMessage.GetMessageBodyLine( Sender    : TObject
                                            ; LineNum   : Integer
                                            ; MsgLine   : PChar
                                            ; MaxLen    : Integer
                                            ; var More  : Boolean
                                            );
begin
    More := ( LineNum <= mmoMessageBody.Lines.Count );
    if More then
        StrPCopy( MsgLine
                , Copy( mmoMessageBody.Lines[ LineNum - 1 ], 1, MaxLen - 1 )
                );
end;

procedure TfrmSMTPMessage.SMTPRequestDone( Sender   : TObject
                                         ; RqType   : TSmtpRequest
                                         ; Error    : Word
                                         );
begin
    if Error <> 0 then
    begin
        UpdateSMTPStatus( Sender, Format( 'SMTP Error: %d', [ Error ] ) );
        Exit;
    end;

    case RqType of
        smtpConnect : SmtpClient.Mail;
        smtpMail    : SmtpClient.Quit;
        smtpQuit    : Close;
    end;
end;

procedure TfrmSMTPMessage.btnSendItClick( Sender : TObject );
begin
    with SMTPClient do
    begin
        FromName        := edtFrom.Text;
        RcptName.Clear;
        RcptName.Add( edtTo.Text );
        HdrFrom         := edtFrom.Text;
        HdrTo           := edtTo.Text;
        HdrSubject      := edtSubject.Text;
        if not Connected then
            Connect
        else
            Mail;
    end;
end;

end.
